import { batch } from '../util';
import * as  Keys from '../keys';
import { Actions, ActionConst } from 'react-native-router-flux';
import * as G from '../global';
import redservice from '../redservice';
import carservice from '../carservice';;
export const CARD = 'CARD';
export const MODE = {
    CREATE: 'CREATE',
    UPDATE: 'UPDATE',
    READ: 'READ',
    DELETE: 'DELETE'
}
export const IDENTITY_PROVIDER = 'IDENTITY_PROVIDER';
export const CHECKING_IF_VERIFIED = 'CHECKING_IF_VERIFIED';
export const CHECKING_IF_IS_PENDING_IDENTITY_CONFIRMATION = 'CHECKING_IF_IS_PENDING_IDENTITY_CONFIRMATION';
export const RESET_ALL = 'RESET_ALL';
export const MESSAGE_PARTICIPANTS = 'MESSAGE_PARTICIPANTS';
export const CURRENT_SERVICE_TASK_DEFINITION = 'CURRENT_SERVICE_TASK_DEFINITION';
export const ENTER_CARD = 'ENTER_CARD';
export const NAVIGATING = 'NAVIGATING';
export const PROVIDER_RESPONSE = 'PROVIDER_RESPONSE';
export const PENDING_CONNECTION = 'PENDING_CONNECTION';
export const WEB_RTC_STATE_INITIAL = 'WEB_RTC_STATE_INITIAL';
export const WEB_RTC_STATE_CREATING_OFFER = 'WEB_RTC_STATE_CREATING_OFFER';
export const WEB_RTC_STATE_ICE_CANDIDATE = 'WEB_RTC_STATE_ICE_CANDIDATE';
export const WEB_RTC_STATE_NEGOTIATING = 'WEB_RTC_STATE_NEGOTIATING';
export const WEB_RTC_STREAMS = 'WEB_RTC_STREAMS';
export const WEB_RTC_STATE_RECEIVE_CHANNEL_STATE_CHANGE = 'WEB_RTC_STATE_RECEIVE_CHANNEL_STATE_CHANGE';
export const WEB_RTC_STATE_SETTING_REMOTE_DESCRIPTION = 'WEB_RTC_STATE_SETTING_REMOTE_DESCRIPTION';
export const WEB_RTC_STATE_CREATING_ANSWER = 'WEB_RTC_STATE_CREATING_ANSWER';
export const WEB_RTC_PEER_CONNECTIONS = 'WEB_RTC_PEER_CONNECTIONS';
export const WEB_RTC_SET_LOCAL_DESCRIPTION = 'WEB_RTC_SET_LOCAL_DESCRIPTION';
export const WEB_RTC_SET_REMOTE_DESCRIPTION = 'WEB_RTC_SET_REMOTE_DESCRIPTION';
export const WEB_RTC_ADDING_INCE_CANDIDATE = 'WEB_RTC_ADDING_INCE_CANDIDATE';
export const WEB_RTC_LEFT_CONNECTION = 'WEB_RTC_LEFT_CONNECTION';
export const UNIQUE_MACHINE_SIG = 'UNIQUE_MACHINE_SIG';
export const TEXT_ROOM_VALUE = 'TEXT_ROOM_VALUE';
export const TEXT_ROOM_DATA = 'TEXT_ROOM_DATA';
export const STAR_RATING = 'STAR_RATING';
export const STAR_RATING_COMMENT = 'STAR_RATING_COMMENT';
export const PERMISSIONS = 'PERMISSIONS';
export const MESSAGES = 'MESSAGES';
export const LOGGING_IN_PROCESS = 'LOGGING_IN_PROCESS';
export const WEB_RTC_DATA_CONNECTED = 'WEB_RTC_DATA_CONNECTED';
export const WEB_RTC_REMOTE_STREAM = 'WEB_RTC_REMOTE_STREAM';
export const WEB_RTC_ICE_CONNECTIONS_STATE = 'WEB_RTC_ICE_CONNECTIONS_STATE';
export const WEB_RTC_PEER_CONNECTED = 'WEB_RTC_PEER_CONNECTED';
export const z = 'IGNORE_LABORER_POSITION';
export const CUSTOMER_PROMO_CODE_ENTRY = 'CUSTOMER_PROMO_CODE_ENTRY';
export const CUSTOMER_PROMO_CODE = 'CUSTOMER_PROMO_CODE';
export const HAS_EVALUATED_LABORER = 'HAS_EVALUATED_LABORER';
export const HAS_EVALUATED_CUSTOMER = 'HAS_EVALUATED_CUSTOMER';
export const GETTING_POTENTIAL_SERVICE_TASK_SELECTIONS = 'GETTING_POTENTIAL_SERVICE_TASK_SELECTIONS';
export const POTENTIAL_SERVICE_TASK_SELECTIONS = 'POTENTIAL_SERVICE_TASK_SELECTIONS';
export const SETTING_POTENTIAL_SERVICE_TASK_SELECTIONS = 'SETTING_POTENTIAL_SERVICE_TASK_SELECTIONS';
export const POTENTIAL_SERVICE_TASK_SELECTION_LIST = 'POTENTIAL_SERVICE_TASK_SELECTION_LIST';
export const CUSTOMER_NOTIFICATION_COUNT = 'CUSTOMER_NOTIFICATION_COUNT';
export const LABORER_NOTIFICATION_COUNT = 'LABORER_NOTIFICATION_COUNT';
export const HERO_NOTIFICATION_COUNT = 'HERO_NOTIFICATION_COUNT';
export const USER_NOTIFICATION_COUNT = 'USER_NOTIFICATION_COUNT';
export const GETTING_HERO_CURRENT_PROVIDER = 'GETTING_HERO_CURRENT_PROVIDER';
export const HERO_CURRENT_LABORER = 'HERO_CURRENT_LABORER';
export const HERO_USER = 'HERO_USER';
export const GETTING_HERO_CURRENT_LABORER = 'GETTING_HERO_CURRENT_LABORER';
export const HERO_CURRENT_PROVIDER = 'HERO_CURRENT_PROVIDER';
export const HERO_CURRENT_PROVIDER_LABORERS = 'HERO_CURRENT_PROVIDER_LABORERS';
export const START_ADDRESS_ONLY = 'START_ADDRESS_ONLY';
export const STATUS_MODAL_VISIBLE = 'STATUS_MODAL_VISIBLE';
export const STATUS_MODAL_FUNC = 'STATUS_MODAL_FUNC';
export const GETTING_HERO_CURRENT_LABORER_EVENTS = 'GETTING_HERO_CURRENT_LABORER_EVENTS';
export const EMPLOYEE_SEARCH_SELECTION = 'EMPLOYEE_SEARCH_SELECTION';
export const CACHE_MAKE_MODEL_YEAR = 'CACHE_MAKE_MODEL_YEAR';
export const HERO_CURRENT_LABORER_EVENTS = 'HERO_CURRENT_LABORER_EVENTS';
export const FIXING_LABORER = 'FIXING_LABORER';
export const CAR_REDUCER = 'carReducer';
export const ASYNC_STORE = 'ASYNC_STORE';
export const SHOULD_SIGN_SLA = 'SHOULD_SIGN_SLA';
export const LOADING_HERO_SERVICETASK_CUSTOMER = 'LOADING_HERO_SERVICETASK_CUSTOMER';
export const CUSTOMER_FOOTER_STATE = 'CUSTOMER_FOOTER_STATE';
export const START_ADDRESS_TEXT = 'START_ADDRESS_TEXT';
export const END_ADDRESS_TEXT = 'END_ADDRESS_TEXT';
export const TOWING = 'TOWING';
export const HOME_ANIMATION_CONFIGURATION = 'HOME_ANIMATION_CONFIGURATION';
export const OIL_CHANGE = 'OIL_CHANGE';
export const ROADSIDE_ASSISTANCE = 'ROADSIDE_ASSISTANCE';
export const CAR_WASH = 'CAR_WASH';
export const ENTER_START_ADDRESS = 'ENTER_START_ADDRESS';
export const ENTERED_START_ADDRESS = 'ENTERED_START_ADDRESS';
export const ENTER_END_ADDRESS = 'ENTER_END_ADDRESS';
export const ENTERED_END_ADDRESS = 'ENTERED_END_ADDRESS';
export const UI_UPDATE = 'UI_UPDATE';
export const UI_UPDATE_MERGE = 'UI_UPDATE_MERGE';
export const CREDIT_CARD_VALID = 'CREDIT_CARD_VALID';
export const LOADING_SERVICE_TASK_OPTIONS = 'LOADING_SERVICE_TASK_OPTIONS';
export const MAP_COORDINATES = 'MAP_COORDINATES';
export const POSITION_POINT = 'POSITION_POINT';
export const DISPLAYING_CARD_INFORMATION = 'DISPLAYING_CARD_INFORMATION';
export const DISABLE_BTNS = 'DISABLE_BTNS';
export const END_ADDRESS = 'END_ADDRESS';
export const PLACING_TASK_ORDER = 'PLACING_TASK_ORDER';
export const SET_VEHICLE = 'SET_VEHICLE';
export const START_ADDRESS = 'START_ADDRESS';
export const START_ADDRESS_NAME = 'START_ADDRESS_NAME';
export const IS_AVAILABLE = 'IS_AVAILABLE';
export const END_ADDRESS_NAME = 'END_ADDRESS_NAME';
export const PIN_DRAG_END_ADDRESS = 'PIN_DRAG_END_ADDRESS';
export const PIN_DRAG_START_ADDRESS = 'PIN_DRAG_START_ADDRESS';
export const START_DEST_LOCATIONS = 'START_DEST_LOCATIONS';
export const CURRENT_PAGE = 'CURRENT_PAGE';
export const PLACE_ORDER = 'PLACE_ORDER';
export const DRIVING_DIRECTIONS = 'DRIVING_DIRECTIONS';
export const UI_MODE = 'UI_MODE';
export const CUSTOMER_MODE = 'CUSTOMER_MODE';
export const NO_MODE = 'NO_MODE';
export const LABORER_MODE = 'LABORER_MODE';
export const PROVIDER_MODE = 'PROVIDER_MODE';
export const WAITING_MODE = 'WAITING_MODE';
export const HERO_MODE = 'HERO_MODE';
export const SIGNED_OUT = 'signed_out';
export const ALL_MODE = 'ALL_MODE';
export const REMOTE_LIST = 'REMOTE_LIST';
export const STATUS = 'STATUS';
export const INFO = 'INFO';
export const IS_FRONT = 'IS_FRONT';
export const SELF_VIEW_SRC = 'SELF_VIEW_SRC';
export const CURRENT_ROOM_ID = 'CURRENT_ROOM_ID';
export const TEXT_ROOM_CONNECTED = 'TEXT_ROOM_CONNECTED';
export const RECTIFY_PAYMENT_INFORMATION = 'RECTIFY_PAYMENT_INFORMATION';
export const LIST_ITEM_HEIGHT = 44;
export const VISIBLE_SELECTION_ITEMS = 4;

export const onScreen = (state, key) => {
    if (getScene(state)) {
        return getScene(state) === key;
    }
    return false;
}
export const getScene = state => {
    var scent = Actions.currentScene;

    return scent || null;
}

export const log = (e) => {
    if (G.DEBUG_MODE) {
        console.log(e);
        if (G.DEBUG_MODE_DETAILED)
            if (arguments.length > 1) {
                for (var i = 1; i < arguments.length; i++) {
                    console.log(arguments[i]);
                }
            }
    }
}

export const HasPermission = (state, perm) => {
    var permissions = Get(state, PERMISSIONS) || [];

    return permissions.find(x => x === perm);
}

export const HPU = (state, perm) => {
    if (HP(state, perm)) {
        return { display: 'none' }
    }
    return {};
}
export const HP = HasPermission;

export const activeJobRelated = state => {
    switch (state.routes.scene.sceneKey) {
        case Keys.LaborerProfile:
        case Keys.LaborProcess:
        case Keys.LaborerTracking:
            return true;
    }
    return false;
}

export const isACustomerBillScreen = state => {
    switch (state.routes.scene.sceneKey) {
        case Keys.PayForJob:
            return true;
    }
    return false;
}
export const isEvaluateLaborerPage = state => {
    switch (state.routes.scene.sceneKey) {
        case Keys.BillConfirmed:
            return true;
    }
    return false;
}
export const _catch = (e) => {
    return Promise.resolve().then(() => {
        if (e && e.message && e.message.json) {
            return e.message.json().then(c => { log(c); return c; });
        }
        return Promise.reject(e);
    }).catch(() => {
        log(e)
        return e;
    })
}
export const catchAnd = (then) => {
    then = then || (() => { });
    return (e) => _catch(e).then(then).catch(() => { });
}
export const isEvaluateCustomerPage = state => {
    switch (state.routes.scene.sceneKey) {
        case Keys.WorkCost:
            return true;
    }
    return false;
}
export const isALaborerBillScreen = state => {
    switch (state.routes.scene.sceneKey) {
        case Keys.WorkCost:
        case Keys.ChangeServiceTask:
            return true;
    }
    return false;
}
export function Combine(state, name, id, value) {
    return Object.assign(
        {},
        Get(state, name),
        { [id]: value });
}
export function Update(state, name, id, value) {
    var update = Combine(state, name, id, value);
    return Object.assign({}, state, { [name]: update });
}
export function UIc(state, name, id, value) {
    return UI(name, Combine(state, name, id, value));
}
export const CanSeeDispute = disputeState => {
    switch (disputeState) {
        case DISPUTE_STATES.CUSTOMER_CANCELED:
        case DISPUTE_STATES.DONE:
            return false;
    }
    return true;
}
var _batch_group = [];
export function UIBc(state, name, id, value) {
    return (UIc(state, name, id, value));
}
export function UIC(name, id, value) {
    return (dispatch, getState) => {
        dispatch(UIc(getState(), name, id, value));
    }
}
export function Name(a, b, c, d) {
    return (a || '') + (a && b ? '#' : '') + (b || '') + (c && b ? '#' : '') + (c || '') + (c && d ? '#' : '') + (d || '');
}
export function GetC(state, name, id) {
    var val = Get(state, name);
    if (val && val.hasOwnProperty(id)) {
        return val[id];
    }
    else if (val && Array.isArray(val)) {
        return val.find(t => t.id === id) || null;
    }
    return null;
}

export function Getor(state, name) {
    var obj = Get(state, name);
    if (obj) {
        for (var i in obj) {
            if (obj[i]) {
                return true;
            }
        }
    }
    return false;
}
var executedCalls = {};
export function execute(func, resolve, name) {
    resolve = resolve || (function (t) { });
    return Promise.resolve().then(() => {
        var res = func().then(res => { resolve(res); return res; }).then(t => {
            executedCalls[name] = Object.assign({}, executedCalls[name], {
                result: t
            });
            return t;
        });
        if (executedCalls[name]) {
            return executedCalls[name].result;
        }
        return res;
    })
}

export function UIMerger(name, value, store) {
    if (store) {
        return {
            type: UI_UPDATE_MERGE,
            name,
            value,
            store: 'uiReducer',
            storePart: name
        }
    }
    return {
        type: UI_UPDATE_MERGE,
        name,
        value
    }
}
export function UI(name, value, store) {
    if (store) {
        return {
            type: UI_UPDATE,
            name,
            value,
            store: 'uiReducer',
            storePart: name
        }
    }
    return {
        type: UI_UPDATE,
        name,
        value
    }
}

export const WEB_RTC = 'WEB_RTC';
export const WAITING_FOR = 'WAITING_FOR';
export function waitingFor(name, value) {
    return (dispatch, getState) => {
        UIC(WAITING_FOR, name, value)(dispatch, getState);
    }
}

function isSocketRequired(state) {
    var _w = Get(state, REQUIRES_SOCKET);
    for (var i in _w) {
        if (_w[i]) {
            return i;
        }
    }
    return false;
}

export function IsWaiting(state) {
    var _w = Get(state, WAITING_FOR);
    for (var i in _w) {
        if (_w[i]) {
            return i;
        }
    }
    return false;
}
export function IsBusy(state, keys) {
    for (var i = keys.length; i--;) {
        if (state.uiReducer[keys[i]]) {
            return true;
        }
    }
    return false;
}
export function And(state, keys) {
    for (var i = keys.length; i--;) {
        if (!state.uiReducer[keys[i]]) {
            return false;
        }
    }
    return true;
}
export function simple(func, param, states, callback, error) {
    return (dispatch, getState) => {
        var state = getState();
        var state1 = states[1];
        var state2 = states[0];
        if (!Get(state, state1)) {
            dispatch(UI(state1, true));
            return func(param).then(res => {
                dispatch(UI(state2, res));
                if (callback) {
                    callback(res, dispatch, getState);
                }
            }).catch(catchAnd((e) => {
                if (error) {
                    error(e, dispatch, getState);
                }
            })).then(() => {
                dispatch(UI(state1, false));
            });
        }
        return Promise.resolve();
    }
}

export function simpleC(func, param, states, callback, error) {
    return (dispatch, getState) => {
        var state = getState();
        var state0 = states[2];
        var state1 = states[1];
        var state2 = states[0];
        if (!GetC(state, state1, state0)) {
            dispatch(UIC(state1, state0, true));
            return func(param).then(res => {
                dispatch(UIC(state2, state0, res));
                if (callback) {
                    callback(res, dispatch, getState);
                }
            }).catch(catchAnd((e) => {
                if (error) {
                    error(e, dispatch, getState);
                }
            })).then(() => {
                dispatch(UIC(state1, state0, false));
            });
        }
        return Promise.resolve();
    }
}

export function Get(state, key) {
    if (state)
        return state.uiReducer[key];
    return null;
}


var _batch_group = [];
export function UIB(name, value) {
    return dispatch => {
        _batch_group.push(UI(name, value));
    };
}

export function UIBatch(name, value) {
    _batch_group.push(UI(name, value));
}

export function UIBatchMerger(name, value) {
    _batch_group.push(UIMerger(name, value));
}

export function Process() {
    return dispatch => {
        _process(dispatch);
    }
}
export function _process(dispatch) {
    dispatch(batch(_batch_group));
    _batch_group = [];
}

export const CARMAKES = 'CARMAKES';
export const GETTING_CARMAKES = 'GETTING_CARMAKES';
export const getCarMakes = () => {
    return (dispatch, getState) => {
        var state = getState();
        if (!IsBusy(state, [GETTING_CARMAKES])) {
            dispatch(UI(GETTING_CARMAKES, true));
            return carservice.getAllMakes().then(makes => {
                var submakes = makes.Results;
                dispatch(UI(CARMAKES, submakes));
            }).catch(_catch).then(() => {
                dispatch(UI(GETTING_CARMAKES, false));
            })
        }
    }
}

export const VINS = 'VINS';
export const GETTING_VINS = 'GETTING_VINS';
export const getVin = (val, callback) => {
    return (dispatch, getState) => {
        var state = getState();
        if (!GetC(state, GETTING_VINS, val)) {
            UIC(GETTING_VINS, val, true)(dispatch, getState);
            return carservice.getVin(val).then(makes => {
                var submakes = makes.Results;
                dispatch(UIC(VINS, val, submakes));
                if (callback) {
                    callback(submakes);
                }
            }).catch(_catch).then(() => {
                UIC(GETTING_VINS, val, false)(dispatch, getState);
            })
        }
    };
};

export const CARMODELS = 'CARMODELS';
export const GETTING_CAR_MODELS = 'GETTING_CAR_MODELS';
export const getCarModels = (make) => {
    return (dispatch, getState) => {
        var state = getState();
        if (!GetC(state, GETTING_CAR_MODELS, make)) {
            UIC(GETTING_CAR_MODELS, make, true)(dispatch, getState);
            return carservice.getModelsForMake(make).then(makes => {
                var submakes = makes.Results;
                dispatch(UIC(CARMODELS, make, submakes));
            }).catch(_catch).then(() => {
                (UIC(GETTING_CAR_MODELS, make, false))(dispatch, getState);
            })
        }
    }
}

export const UI_DEFINIONS = 'UI_DEFINIONS';
export const CURRENT_UI_DEFINITION = 'CURRENT_UI_DEFINITION';
export const LOADING_UI_DEFINITIONS = 'LOADING_UI_DEFINITIONS';
export const getUIDefinition = (objectType) => {
    return simpleC(redservice.getUIDefinition, { objectType }, [UI_DEFINIONS, LOADING_UI_DEFINITIONS, objectType]);
}

export const OBJECT_LISTS = 'OBJECT_LISTS';
export const LOADING_OBJECT_LISTS = 'LOADING_OBJECT_LISTS';
export const getRedObjectList = (objectType) => {
    return simpleC(redservice.getAllRedObject, { objectType }, [OBJECT_LISTS, LOADING_OBJECT_LISTS, objectType]);
}
export const LOADING_RED_OBJECT = 'LOADING_RED_OBJECT';
export const CURRENT_RED_OBJECT = 'CURRENT_RED_OBJECT';
export const getRedObject = (objectType, id, callback) => {
    return simpleC(redservice.getRedObject, { objectType, id }, [objectType, LOADING_RED_OBJECT, id], (value, dispatch, getState) => {
        if (callback) {
            callback(value);
        }
    });
}
export const LOADING_DEFAULT_RED_OBJECT = 'LOADING_DEFAULT_RED_OBJECT';
export const getDefaultRedObject = (objectType, callback) => {
    return simple(redservice.getUIDefault, { objectType }, [objectType, LOADING_DEFAULT_RED_OBJECT], (value, dispatch, getState) => {
        if (callback) {
            callback(value);
        }
    });
}

export const UPDATING_RED_OBJECT = 'UPDATING_RED_OBJECT';
export const updateRedObject = (objectType, id, obj, callback) => {
    return simpleC(redservice.updateRedObject, { objectType, id, obj }, [objectType, UPDATING_RED_OBJECT, id], (value, dispatch, getState) => {
        if (callback) {
            callback(value);
        }
    });
}

export const CREATING_RED_OBJECT = 'CREATING_RED_OBJECT';
export const createRedObject = (objectType, obj, callback) => {
    return simple(redservice.createRedObject, { objectType, obj }, ["currect", CREATING_RED_OBJECT], (value, dispatch, getState) => {
        if (callback) {

            callback(value);
            dispatch(UIC(objectType, value.id, value))
        }
    });
}

export const DELETING_RED_OBJECT = 'DELETING_RED_OBJECT';
export const deleteRedObject = (objectType, id, callback) => {
    return simpleC(redservice.deleteRedObject, { objectType, id }, [objectType, DELETING_RED_OBJECT, id], (value, dispatch, getState) => {
        if (callback) {
            callback(value);
        }
    });
}

