import createService from './service';
import {
    Platform,
    PermissionsAndroid
} from 'react-native';
import { parameters } from './endPoints';
const endpoints = {
}

const googleApiKey = 'AIzaSyCbpZxMj8LfOzVQ7wnOdLXWH-bYhpweERU';
const googleAndroidKey = 'AIzaSyCwvnIvZAm3UQoaiw8q687cLWfLf6SiW9Q';
export default {
    getApiKey: async () => {
        return Promise.resolve().then(() => googleApiKey);
    },
    getDirectionsKey: async () => {
        if (Platform.OS === 'android') {
            return Promise.resolve().then(() => googleAndroidKey);
        }
        return Promise.resolve().then(() => googleApiKey);
    },
    checkLocationPermision: async () => {
        if (Platform.OS === 'android') {
            return PermissionsAndroid.check(PermissionsAndroid.PERMISSIONS.ACCESS_FINE_LOCATION).then(res => {
                console.log(res);
                if (!res) {
                    return PermissionsAndroid.request(
                        PermissionsAndroid.PERMISSIONS.ACCESS_FINE_LOCATION,
                        {
                            'title': 'Location Needed',
                            'message': 'We need your location so we can provide service.'
                        });
                }
            });
        }
    }
};