((string) => {
    
        if (!string.lowercaseFirstLetter) {
            Object.defineProperty(string, 'lowercaseFirstLetter', {
                enumerable: false,
                writable: true,
                configurable: true,
                value: function () {
                    var string = this;
                    if (string.length > 0) {
                        return string.charAt(0).toLowerCase() + string.slice(1);
                    }
                    return string;
                }
            });
        }
    })(String.prototype);
    
    ((array) => {
    
        if (!array.unique) {
            Object.defineProperty(array, 'unique', {
                enumerable: false,
                writable: true,
                configurable: true,
                value: function (func) {
                    var result = [];
                    var finalresult = [];
                    func = func || function (x) { return x; };
                    var collection = this;
                    for (var i = 0; i < collection.length; i++) {
                        //if (func(collection[i])) {
                        if (result.indexOf(func(collection[i])) === -1) {
                            result.push(func(collection[i]));
                            finalresult.push(collection[i]);
                        }
                        //}
                    }
                    return finalresult;
                    //return result;
                }
            });
        }
        if (!array.interpolate) {
            Object.defineProperty(array, 'interpolate', {
                enumerable: false,
                writable: true,
                configurable: true,
                value: function (start, stop, func) {
                    var collection = this;
                    func = func || function (x) { return x; };
                    for (var i = start; i < stop; i++) {
                        if (collection instanceof Float32Array) {
                            collection[i - start] = (func(i));
                        }
                        else
                            collection.push(func(i, i - start));
                    }
                    return collection;
                }
            });
        }
        if (!array.subset) {
            Object.defineProperty(array, 'subset', {
                enumerable: false,
                writable: true,
                configurable: true,
                value: function (start, stop) {
                    var collection = this;
                    stop = Math.min(collection.length, stop === undefined || stop === null ? collection.length : stop);
                    start = Math.min(collection.length, start === undefined || start === null ? collection.length : start);
                    start = start < 0 ? 0 : start;
                    stop = stop < 0 ? 0 : stop;
                    var result = this instanceof Float32Array ? new Float32Array(stop - start) : [];
                    for (var i = start; i < stop; i++) {
                        if (this instanceof Float32Array) {
                            result[i - start] = collection[i];
                        }
                        else {
                            result.push(collection[i]);
                        }
    
                    }
                    return (result);
                }
            });
        }
        if (!array.last) {
            Object.defineProperty(array, 'last', {
                enumerable: false,
                writable: true,
                configurable: true,
                value: function (func) {
                    func = func || function () { return true; };
                    if (typeof (func) !== 'function') {
                        var temp = func;
                        func = function (x) {
                            return temp === x;
                        }
                    }
                    var collection = this;
                    for (var i = collection.length; i--;) {
                        if (func(collection[i])) {
                            var result = (collection[i])
                            return result;
                        }
                    }
                    return null;
                }
            });
        }
    })(Array.prototype);
    
    export default {};